/*
 * SWTButtonPeer.java
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.awt.Button;
import java.awt.event.ActionEvent;
import java.awt.peer.ButtonPeer;
import java.util.concurrent.Callable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Widget;

/**
 * @author Emmanuel Puybaret
 */
public class SWTButtonPeer extends SWTComponentPeer implements ButtonPeer {
  public SWTButtonPeer(SWTToolkit toolkit, Button awtButton) {
    super(toolkit, awtButton);
    
    setLabel(awtButton.getLabel());
  }

  @Override
  public Button getAWTObject() {
    return (Button)super.getAWTObject();
  }
  
  @Override
  protected org.eclipse.swt.widgets.Button getSWTWidget() {
    return (org.eclipse.swt.widgets.Button)super.getSWTWidget();
  }
  
  @Override
  protected Widget createSWTWidget() {
     return new org.eclipse.swt.widgets.Button(getSWTParent(), SWT.PUSH);
  }

  protected void handleSWTSelectionEvent(Event ev) {
    postAWTEvent(new ActionEvent(getAWTObject(), ActionEvent.ACTION_PERFORMED, 
        getAWTObject().getActionCommand(), ev.time, getModifiers(ev.stateMask)));
  }

  public void setLabel(final String label) {
    invokeInSWTDisplayThread(new Callable<Void>() {
      public Void call() {
        getSWTWidget().setText(label);
        return null;
      }
    });
  }

  @Override
  public boolean isFocusable() {
    return true;
  }
}
