/*
 * SWTCheckboxMenuItemPeer.java 
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.awt.CheckboxMenuItem;
import java.awt.ItemSelectable;
import java.awt.MenuItem;
import java.awt.event.ItemEvent;
import java.awt.peer.CheckboxMenuItemPeer;
import java.util.concurrent.Callable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Widget;

/**
 * @author Emmanuel Puybaret
 */
public class SWTCheckboxMenuItemPeer extends SWTMenuItemPeer implements CheckboxMenuItemPeer {
  public SWTCheckboxMenuItemPeer(SWTToolkit toolkit,
                                 CheckboxMenuItem awtCheckboxMenuItem) {
    super(toolkit, awtCheckboxMenuItem);
  }

  @Override
  protected Widget createSWTWidget() {
    org.eclipse.swt.widgets.Menu parent = (org.eclipse.swt.widgets.Menu)getSWTParent();
    org.eclipse.swt.widgets.MenuItem swtMenuItem = new org.eclipse.swt.widgets.MenuItem(parent, SWT.CHECK);
    MenuItem awtCheckboxMenuItem = getAWTObject();
    setLabel(swtMenuItem, awtCheckboxMenuItem.getLabel(), awtCheckboxMenuItem.getShortcut());
    setEnabled(swtMenuItem, awtCheckboxMenuItem.isEnabled());
    setState(((CheckboxMenuItem)awtCheckboxMenuItem).getState());
    return swtMenuItem;
  }

  @Override
  protected void handleSWTSelectionEvent(Event ev) {
    final boolean selected = ((org.eclipse.swt.widgets.MenuItem)getSWTWidget()).getSelection();
    postAWTEvent(new ItemEvent((ItemSelectable)getAWTObject(), ItemEvent.ITEM_STATE_CHANGED, 
        getAWTObject().getActionCommand(), selected ? ItemEvent.SELECTED : ItemEvent.DESELECTED));
  }

  public void setState(boolean selected) {
    org.eclipse.swt.widgets.MenuItem swtMenuItem = (org.eclipse.swt.widgets.MenuItem)getSWTWidget();
    if (swtMenuItem != null) {
      setState(swtMenuItem, selected);
    }
  }

  protected void setState(final org.eclipse.swt.widgets.MenuItem swtMenuItem, final boolean selected) {
    invokeInSWTDisplayThread(new Callable<Void>() {
      public Void call() {
        swtMenuItem.setSelection(selected);
        return null;
      }
    });
  }
}
