/*
 * SWTFontConfiguration.java
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.nio.charset.Charset;

import sun.awt.FontConfiguration;

public class SWTFontConfiguration extends FontConfiguration {
  public SWTFontConfiguration(SWTGraphicsEnvironment environment) {
    super(environment);
  }

  public SWTFontConfiguration(SWTGraphicsEnvironment environment,
                              boolean preferLocaleFonts,
                              boolean preferPropFonts) {
    super(environment, preferLocaleFonts, preferPropFonts);
  }

  @Override
  public String getFallbackFamilyName(String fontName,
                                      String defaultFallback) {
    // Maintain compatibility with old font.properties files, which
    // either had aliases for TimesRoman & Co. or defined mappings for them.
    String compatibilityName = getCompatibilityFamilyName(fontName);
    if (compatibilityName != null) {
      return compatibilityName;
    }
    return defaultFallback;
  }

  protected String getFileNameFromComponentFontName(String componentFontName) {
    return getFileNameFromPlatformName(componentFontName);
  }

  public String getFaceNameFromComponentFontName(String componentFontName) {
    return componentFontName;
  }

  protected String getEncoding(String awtFontName,
                               String characterSubsetName) {
    encoding = "default";
    return encoding;
  }

  protected void initReorderMap() {
  }

  @Override
  protected Charset getDefaultFontCharset(String arg0) {
    return null;
  }
}
