/*
 * SWTGraphicsEnvironment.java
 * 
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Visit eTeks web site for up-to-date versions of this file and other Java
 * tools and tutorials : http://www.eteks.com/
 */
package com.eteks.swtawt;

import java.awt.GraphicsDevice;
import java.util.Locale;

import sun.awt.FontConfiguration;
import sun.java2d.SunGraphicsEnvironment;

/**
 * @author Emmanuel Puybaret
 */
public class SWTGraphicsEnvironment extends SunGraphicsEnvironment {
  public SWTGraphicsEnvironment() {
  }
  
  /**
   * Returns the number of screens.
   * @return 1
   */
  protected int getNumScreens() {
    return 1;
  }

  @Override
  public String [] getAvailableFontFamilyNames(Locale requestedLocale) {
    return getAvailableFontFamilyNames();
  }
  
  protected GraphicsDevice makeScreenDevice(int screenNum) {
    return new SWTGraphicsDevice(screenNum);
  }

  @Override
  protected FontConfiguration createFontConfiguration() {
    return new SWTFontConfiguration(this);
  }

  @Override
  public FontConfiguration createFontConfiguration(boolean preferLocaleFonts,
                                                   boolean preferPropFonts) {
    return new SWTFontConfiguration(this, preferLocaleFonts, preferPropFonts);
  }
}
