/*
 * SWTLabelPeer.java
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.awt.Label;
import java.awt.peer.LabelPeer;
import java.util.concurrent.Callable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Widget;

/**
 * @author Emmanuel Puybaret
 */
public class SWTLabelPeer extends SWTComponentPeer implements LabelPeer {

  public SWTLabelPeer(SWTToolkit toolkit, Label awtLabel) {
    super(toolkit, awtLabel);
    
    setText(awtLabel.getText());
    setAlignment(awtLabel.getAlignment());
  }

  @Override
  protected Widget createSWTWidget() {
    return new org.eclipse.swt.widgets.Label(getSWTParent(), 0);
  }

  @Override
  public Label getAWTObject() {
    return (Label)super.getAWTObject();
  }
  
  @Override
  protected org.eclipse.swt.widgets.Label getSWTWidget() {
    return (org.eclipse.swt.widgets.Label)super.getSWTWidget();
  }
  
  public void setAlignment(final int alignment) {
    invokeInSWTDisplayThread(new Callable<Void>() {
      public Void call() {
        switch (alignment) {
          case Label.CENTER :
            getSWTWidget().setAlignment(SWT.CENTER);
            break;
          case Label.RIGHT :
            getSWTWidget().setAlignment(SWT.RIGHT);
            break;
          default : // Label.LEFT
            getSWTWidget().setAlignment(SWT.LEFT);
            break;
        }
        return null;
      }
    });
  }

  public void setText(final String label) {
    invokeInSWTDisplayThread(new Callable<Void>() {
      public Void call() {
        getSWTWidget().setText(label);
        return null;
      }
    });
  }
}
