/*
 * SWTMenuBarPeer.java 
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.peer.MenuBarPeer;
import java.util.concurrent.Callable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Widget;

/**
 * @author Emmanuel Puybaret
 */
public class SWTMenuBarPeer extends SWTMenuComponentPeer implements MenuBarPeer {
  public SWTMenuBarPeer(SWTToolkit toolkit, MenuBar awtMenuBar) {
    super(toolkit, awtMenuBar);
  }

  @Override
  protected Widget createSWTWidget() {
    Shell parent = (Shell)getSWTParent();
    // Wait until parent is available to create SWT menu bar and its menus
    org.eclipse.swt.widgets.Menu swtMenuBar = new org.eclipse.swt.widgets.Menu(parent, SWT.BAR);
    MenuBar awtMenuBar = (MenuBar)getAWTObject();
    for (int i = 0; i < awtMenuBar.getMenuCount(); i++) {
      addMenu(swtMenuBar, awtMenuBar.getMenu(i));
    }
    parent.setMenuBar(swtMenuBar);
    return swtMenuBar;
  }

  public void addHelpMenu(Menu m) {
    addMenu(m);
  }

  public void addMenu(Menu awtMenu) {
    org.eclipse.swt.widgets.Menu swtMenuBar = (org.eclipse.swt.widgets.Menu)getSWTWidget();
    if (swtMenuBar != null) {
      addMenu(swtMenuBar, awtMenu);
    }
  }

  private void addMenu(final org.eclipse.swt.widgets.Menu swtMenuBar, final Menu awtMenu) {
    invokeInSWTDisplayThread(new Callable<Void>() {
      @SuppressWarnings("deprecation")
      public Void call() {
        SWTMenuPeer menuPeer = (SWTMenuPeer)awtMenu.getPeer();
        menuPeer.setSWTParent(swtMenuBar);
        menuPeer.initSWTWidget();          
        return null;
      }
    });
  }

  public void delMenu(int index) {
    // Nothing to do, menu will be automatically deleted once disposed
  }
}
