/*
 * SWTPopupMenuPeer.java 
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.awt.Component;
import java.awt.Event;
import java.awt.Frame;
import java.awt.PopupMenu;
import java.awt.peer.PopupMenuPeer;
import java.util.concurrent.Callable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Decorations;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Widget;

/**
 * @author Emmanuel Puybaret
 */
public class SWTPopupMenuPeer extends SWTMenuPeer implements PopupMenuPeer {
  public SWTPopupMenuPeer(SWTToolkit toolkit, PopupMenu awtPopupMenu) {
    super(toolkit, awtPopupMenu);
  }

  @Override
  protected Widget createSWTWidget() {
    org.eclipse.swt.widgets.Menu swtMenu = new org.eclipse.swt.widgets.Menu((Decorations)getSWTParent(), SWT.POP_UP);
    PopupMenu awtPopupMenu = (PopupMenu)getAWTObject();
    for (int i = 0; i < awtPopupMenu.getItemCount(); i++) {
      addItem(awtPopupMenu.getItem(i), swtMenu);
    }
    return swtMenu;
  }
  
  @Override
  protected org.eclipse.swt.widgets.Menu getSWTWidget() {
    return (org.eclipse.swt.widgets.Menu)super.getSWTWidget();
  }
  
  public void show(final Event ev) {
    invokeInSWTDisplayThread(new Callable<Void>() {
      @SuppressWarnings("deprecation")
      public Void call() {
        // Create SWT popup widget
        setSWTParent((Shell)((SWTComponentPeer)((Frame)getAWTObject().getParent()).getPeer()).getSWTWidget());
        initSWTWidget();
        org.eclipse.swt.widgets.Menu swtPopupMenu = (org.eclipse.swt.widgets.Menu)getSWTWidget();
        // Map event coordinates to display coordinates 
        Point point = getToolkit().getSWTDisplay().map(
            (Control)((SWTObjectPeer)((Component)ev.target).getPeer()).getSWTWidget(), null, ev.x, ev.y);
        // Display popup
        swtPopupMenu.setLocation(point.x, point.y);
        swtPopupMenu.setVisible(true);
        return null;
      }
    });
  }
  
  @Override
  protected void handleSWTHideEvent(org.eclipse.swt.widgets.Event ev) {
    dispose();
  }
}
