/*
 * SWTTrayPeer.java 
 *
 * Copyright (c) 2007 Emmanuel PUYBARET / eTeks <info@eteks.com>. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.eteks.swtawt;

import java.awt.Dimension;
import java.awt.SystemTray;
import java.awt.peer.SystemTrayPeer;

import org.eclipse.swt.widgets.Widget;

/**
 * @author Emmanuel Puybaret
 */
public class SWTTrayPeer extends SWTObjectPeer implements SystemTrayPeer {
  public SWTTrayPeer(SWTToolkit toolkit, SystemTray awtTray) {
    super(toolkit, awtTray);
    initSWTWidget();
  }

  @Override
  protected Widget createSWTWidget() {
    return getToolkit().getSWTDisplay().getSystemTray();
  }

  @Override
  protected Widget getSWTParent() {
    return null;
  }

  public Dimension getTrayIconSize() {
    return new Dimension(16, 16);
  }
}
